{-|
Description:    

Copyright:      (c) 2020 Samuel May
License:        MPL-2.0
Maintainer:     ag.eitilt@gmail.com

Stability:      experimental
Portability:    portable
-}
module Test.Willow.Unit.Encoding
    ( tests
    ) where


import qualified Test.HUnit as U

import Test.HUnit ( (~:) )

import qualified Test.Willow.Unit.Encoding.Big5 as Big5
import qualified Test.Willow.Unit.Encoding.EucJp as EucJp
import qualified Test.Willow.Unit.Encoding.EucKr as EucKr
import qualified Test.Willow.Unit.Encoding.GB as GB
import qualified Test.Willow.Unit.Encoding.ShiftJis as ShiftJis
import qualified Test.Willow.Unit.Encoding.SingleByte as SingleByte
import qualified Test.Willow.Unit.Encoding.Utf8 as Utf8


tests :: IO U.Test
tests = do
    singleByte <- SingleByte.tests
    return $ "encode/decode" ~: U.TestList
        [ singleByte
        , Big5.tests
        , EucJp.tests
        , EucKr.tests
        , GB.tests
        , ShiftJis.tests
        , Utf8.tests
        ]
